package de.fhmuenster.masterthesis.serialization;

import java.util.Comparator;

import de.fhmuenster.masterthesis.testgeneratorDSL.BPMNDiagram;
import de.fhmuenster.masterthesis.testgeneratorDSL.Declaration;
import de.fhmuenster.masterthesis.testgeneratorDSL.Flow;
import de.fhmuenster.masterthesis.testgeneratorDSL.FlowElement;
import de.fhmuenster.masterthesis.testgeneratorDSL.Test;
import de.fhmuenster.masterthesis.testgeneratorDSL.Variable;

public class DeclarationComparator implements Comparator<Declaration> {
	
	public DeclarationComparator() {
	}
	
	@Override
	public int compare(Declaration left, Declaration right) {
		int declCompare = Integer.compare(getIndexForDeclaration(left), getIndexForDeclaration(right));
		if(declCompare != 0) {
			return declCompare;
		}
		
		return left.getName().compareTo(right.getName());
	}
	
	private static int getIndexForDeclaration(Declaration decl) {
		if(decl instanceof BPMNDiagram) {
			return 0;
		}
		
		if(decl instanceof FlowElement) {
			return 1;
		}
		
		if(decl instanceof Flow) {
			return 2;
		}
		
		if(decl instanceof Variable) {
			return 3;
		}
		
		if(decl instanceof Test) {
			return 4;
		}
		
		System.out.println("no decl");
		
		return 5;
	}
}
